"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.shouldPolyfill = void 0;
function supportsDateStyle() {
    return !!new Intl.DateTimeFormat(undefined, {
        dateStyle: 'short',
    }).resolvedOptions().dateStyle;
}
/**
 * https://bugs.chromium.org/p/chromium/issues/detail?id=865351
 */
function hasChromeLt71Bug() {
    return (new Intl.DateTimeFormat('en', {
        hourCycle: 'h11',
        hour: 'numeric',
    }).formatToParts(0)[2].type !== 'dayPeriod');
}
function shouldPolyfill() {
    return (!('DateTimeFormat' in Intl) ||
        !('formatToParts' in Intl.DateTimeFormat.prototype) ||
        hasChromeLt71Bug() ||
        !supportsDateStyle());
}
exports.shouldPolyfill = shouldPolyfill;
